Customizable error handlers
[git/dscho.git] / t / test-lib.sh
blob05f6e79560ff7e3d92c47221b3ee7adec098e676
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
6 # For repeatability, reset the environment to known value.
7 LANG=C
8 LC_ALL=C
9 PAGER=cat
10 TZ=UTC
11 export LANG LC_ALL PAGER TZ
12 unset AUTHOR_DATE
13 unset AUTHOR_EMAIL
14 unset AUTHOR_NAME
15 unset COMMIT_AUTHOR_EMAIL
16 unset COMMIT_AUTHOR_NAME
17 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
18 unset GIT_AUTHOR_DATE
19 GIT_AUTHOR_EMAIL=author@example.com
20 GIT_AUTHOR_NAME='A U Thor'
21 unset GIT_COMMITTER_DATE
22 GIT_COMMITTER_EMAIL=committer@example.com
23 GIT_COMMITTER_NAME='C O Mitter'
24 unset GIT_DIFF_OPTS
25 unset GIT_DIR
26 unset GIT_EXTERNAL_DIFF
27 unset GIT_INDEX_FILE
28 unset GIT_OBJECT_DIRECTORY
29 unset SHA1_FILE_DIRECTORIES
30 unset SHA1_FILE_DIRECTORY
31 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
32 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
34 # Each test should start with something like this, after copyright notices:
36 # test_description='Description of this test...
37 # This test checks if command xyzzy does the right thing...
38 # '
39 # . ./test-lib.sh
41 error () {
42 echo "* error: $*"
43 trap - exit
44 exit 1
47 say () {
48 echo "* $*"
51 test "${test_description}" != "" ||
52 error "Test script did not set test_description."
54 while test "$#" -ne 0
56 case "$1" in
57 -d|--d|--de|--deb|--debu|--debug)
58 debug=t; shift ;;
59 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
60 immediate=t; shift ;;
61 -h|--h|--he|--hel|--help)
62 echo "$test_description"
63 exit 0 ;;
64 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
65 verbose=t; shift ;;
66 --no-python)
67 no_python=t; shift ;;
69 break ;;
70 esac
71 done
73 exec 5>&1
74 if test "$verbose" = "t"
75 then
76 exec 4>&2 3>&1
77 else
78 exec 4>/dev/null 3>/dev/null
81 test_failure=0
82 test_count=0
84 trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
87 # You are not expected to call test_ok_ and test_failure_ directly, use
88 # the text_expect_* functions instead.
90 test_ok_ () {
91 test_count=$(expr "$test_count" + 1)
92 say " ok $test_count: $@"
95 test_failure_ () {
96 test_count=$(expr "$test_count" + 1)
97 test_failure=$(expr "$test_failure" + 1);
98 say "FAIL $test_count: $1"
99 shift
100 echo "$@" | sed -e 's/^/ /'
101 test "$immediate" = "" || { trap - exit; exit 1; }
105 test_debug () {
106 test "$debug" = "" || eval "$1"
109 test_run_ () {
110 eval >&3 2>&4 "$1"
111 eval_ret="$?"
112 return 0
115 test_expect_failure () {
116 test "$#" = 2 ||
117 error "bug in the test script: not 2 parameters to test-expect-failure"
118 say >&3 "expecting failure: $2"
119 test_run_ "$2"
120 if [ "$?" = 0 -a "$eval_ret" != 0 ]
121 then
122 test_ok_ "$1"
123 else
124 test_failure_ "$@"
128 test_expect_success () {
129 test "$#" = 2 ||
130 error "bug in the test script: not 2 parameters to test-expect-success"
131 say >&3 "expecting success: $2"
132 test_run_ "$2"
133 if [ "$?" = 0 -a "$eval_ret" = 0 ]
134 then
135 test_ok_ "$1"
136 else
137 test_failure_ "$@"
141 test_expect_code () {
142 test "$#" = 3 ||
143 error "bug in the test script: not 3 parameters to test-expect-code"
144 say >&3 "expecting exit code $1: $3"
145 test_run_ "$3"
146 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
147 then
148 test_ok_ "$2"
149 else
150 test_failure_ "$@"
154 # Most tests can use the created repository, but some amy need to create more.
155 # Usage: test_create_repo <directory>
156 test_create_repo () {
157 test "$#" = 1 ||
158 error "bug in the test script: not 1 parameter to test-create-repo"
159 owd=`pwd`
160 repo="$1"
161 mkdir "$repo"
162 cd "$repo" || error "Cannot setup test environment"
163 "$GIT_EXEC_PATH/git" init-db --template=$GIT_EXEC_PATH/templates/blt/ 2>/dev/null ||
164 error "cannot run git init-db -- have you built things yet?"
165 mv .git/hooks .git/hooks-disabled
166 cd "$owd"
169 test_done () {
170 trap - exit
171 case "$test_failure" in
173 # We could:
174 # cd .. && rm -fr trash
175 # but that means we forbid any tests that use their own
176 # subdirectory from calling test_done without coming back
177 # to where they started from.
178 # The Makefile provided will clean this test area so
179 # we will leave things as they are.
181 say "passed all $test_count test(s)"
182 exit 0 ;;
185 say "failed $test_failure among $test_count test(s)"
186 exit 1 ;;
188 esac
191 # Test the binaries we have just built. The tests are kept in
192 # t/ subdirectory and are run in trash subdirectory.
193 PATH=$(pwd)/..:$PATH
194 GIT_EXEC_PATH=$(pwd)/..
195 export PATH GIT_EXEC_PATH
197 # Similarly use ../compat/subprocess.py if our python does not
198 # have subprocess.py on its own.
199 PYTHON=`sed -e '1{
200 s/^#!//
202 }' ../git-merge-recursive` || {
203 error "You haven't built things yet, have you?"
205 "$PYTHON" -c 'import subprocess' 2>/dev/null || {
206 PYTHONPATH=$(pwd)/../compat
207 export PYTHONPATH
209 test -d ../templates/blt || {
210 error "You haven't built things yet, have you?"
213 # Test repository
214 test=trash
215 rm -fr "$test"
216 test_create_repo $test
217 cd "$test"